package JSci.maths.categories;

/**
* This interface defines a category.
* @version 1.0
* @author Mark Hale
*/
public interface Category {
        /**
        * Returns the identity morphism for an object.
        */
        Morphism identity(Object a);
        /**
        * Returns the cardinality of an object.
        * In general, this may not be an Integer.
        */
        Object cardinality(Object a);
        /**
        * Returns a hom-set.
        */
        Homset homset(Object a,Object b);
}

