/*
 * The org.opensourcephysics.display package contains the drawing framework
 * for the book Simulations in Physics.  This framework defines objects that
 * implement the Drawable interface and a DrawingPanel for rendering these objects.
 * Copyright (c) 2005  H. Gould, J. Tobochnik, and W. Christian.
 */
package org.opensourcephysics.display;

abstract class AbstractMouseHandler implements InteractiveMouseHandler {
	void mouseClicked(InteractivePanel panel){}
	void mouseEntered(InteractivePanel panel){}
	void mouseExited(InteractivePanel panel){}
	void mousePressed(InteractivePanel panel){}
	void mouseReleased(InteractivePanel panel){}
	void mouseDragged(InteractivePanel panel){}
	void mouseMoved(InteractivePanel panel){}
}
